'Egy BASIC mintaprogram a PICDEMO panelre, 16F1937 mikrokontrollerre.
'A CS4 csatlakozn egy 8-as DIP kapcsol , s egy LCD a kijelzshez
'Digitlis bemenetek beolvassa, kijelzse, s egy kis jtk a bitekkel
'A program beolvassa a 8 kapcsolt, kirja bitenknt, aztn hexa, s decimlis szmknt.
's - mint egy szmkdos bicikli lakat - bekapcsol egy LED-et, ha a 00011100 a kd

'Config - fuse bit - bellts
'A proci beptett rajelgenertort hasznlom - INTOSC - s kdvdelem - CP - kikapcsolva
'A PLL rajel ngyszerez, s az alacsonyfeszltsg programozs - LVP - kikapcsolva. 
#CONFIG             
    __config _CONFIG1, _FOSC_INTOSC & _CP_OFF
    __config _CONFIG2, _PLLEN_OFF & _LVP_OFF 
#endCONFIG

' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis

'Elszr is kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	4	' Az els adatvezetk az RD.4
	DEFINE LCD_RSREG 	PORTC ' Az LCD Register Select kivezetse a C portra csatlakozik,
	DEFINE LCD_RSBIT 	0	' mgpedig az RC.0 labra. (Tehat az LCD RS - az RC.0 porton van.)
	DEFINE LCD_EREG 	PORTC ' Az enable vezerl bit is a C porton,
	DEFINE LCD_EBIT 	1	' az RC1 portra van kiosztva. (LCD EN - RC.1 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

	TRISA = %11111111	' A PORTA0-7 input, 
	TRISB = %00000000	' A PORTB0-7 output, 
	TRISC = %00000000	' A PORTC 0-7 output
	TRISE = %00000111	' A PORTE 0-2 input

	LED VAR PORTB.0   ' A LED a PORTB.0 -on van

	' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban

	DIP8 var byte	' Ebbe olvassuk majd bele a DIP8 kapcsol llapott
	PUFFER var byte	' Egy tmeneti tr	
    
   	LCDFRISS var BIT ' Egy jelz bit. Azt jelzi, hogy frissteni kell az LCD-n a kirst
    LCDFRISS = 1     ' Bekapcsols utn mindjrt rjunk is az LCD-re
    
main:       
 
    Puffer = DIP8   'Elmentjk a DIP kapcsol utols llapott, aztn beolvassuk bitenknt
    DIP8.0 = PORTA.0 : DIP8.1 = PORTA.1 : DIP8.2 = PORTA.2 : DIP8.3 = PORTA.3
    DIP8.4 = PORTA.4 : DIP8.5 = PORTA.5 : DIP8.6 = PORTE.0 : DIP8.7 = PORTE.1     
    
    If PUFFER != DIP8 THEN  'Ha nem azonos az elz llapottal, akkor
        TOGGLE PORTB.1      'vltjuk az L1 led llapott, ha vltozs van a kdkapcsoln
        LCDFRISS = 1        's frissteni kell az LCD-t is, bebillentjk a jelzbitet               
        'LED = 1, ha a DIP8 00011100  A ! jel a negls, az & az S kapcsolatot jelenti
        LED = !DIP8.7 & !DIP8.6  & !DIP8.5 & DIP8.4 & DIP8.3 & DIP8.2 & !DIP8.1 & !DIP8.0 
    endif
         
    If LCDFRISS = 1 THEN
       LCDOUT $fe,$80,"DIP8: ",#DIP8.7,#DIP8.6,#DIP8.5,#DIP8.4,#DIP8.3,#DIP8.2,#DIP8.1,#DIP8.0 ' irs az els sorba
       LCDOUT $fe,$C0,"H:",hex2 DIP8," D:",dec3 DIP8," LED:",#LED  'Kt szmjegyen hexa, hrom szmjegyen decimlis
       LCDFRISS = 0  'Kirtuk amit kell, a jelz bitet most mr alaphelyzetbe lltjuk                        
    endif 
	      
    goto main		' Ugras a ciklus elejere, kezdodik minden ujra... 

    END				' Itt a progi vege. 
