'Csinljunk egy idalapot!
'A BASIC delay utastsval tudunk idztseket csinlni, de ilyenkor "megll" a program
'Ha egy pontos idalapra van szksgnk, akkor fel kell programoznunk a PIC mikrokontroller 
'valamelyik beptett timer perifrijt. Esetnkben ez most a TIMER2 lesz.
'Ez a timer aztn szablyos idkzkben "megszaktst kr",  

'Config - fuse bit - bellts
'A proci beptett rajelgenertort hasznlom - INTOSC - s kdvdelem - CP - kikapcsolva
'A PLL rajel ngyszerez, s az alacsonyfeszltsg programozs - LVP - kikapcsolva. 
#CONFIG             
    __config _CONFIG1, _FOSC_INTOSC & _CP_OFF
    __config _CONFIG2, _PLLEN_OFF & _LVP_OFF 
#endCONFIG
' Ha pontos idmrs kell, akkor persze akasszunk a procira egy 4 megs kvarcot, s akkor  
' ez legyen az els konfig sor:    __config _CONFIG1, _FOSC_XT & _CP_OFF

    OSCCON = %01101010   ' Belltom 4 megra a bels rajelet

' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis

'Elszr is kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	4	' Az els adatvezetk az RD.4
	DEFINE LCD_RSREG 	PORTC ' Az LCD Register Select kivezetse a C portra csatlakozik,
	DEFINE LCD_RSBIT 	0	' mgpedig az RC.0 labra. (Tehat az LCD RS - az RC.0 porton van.)
	DEFINE LCD_EREG 	PORTC ' Az enable vezerl bit is a C porton,
	DEFINE LCD_EBIT 	1	' az RC1 portra van kiosztva. (LCD EN - RC.1 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD


	TRISA = %00001111	' A PORTA0-3 input, a PORTA 4-7 output
	TRISB = %00000000	' A PORTB0-7 output
	TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output


	PIROSLED var PORTB.0
    
	' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
	' analg portnak hasznlni. 
	' Ezeket az ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
	' Szval most a PORTA0-7 mind mint digitlis port legyen hasznlva.
	
	ADCON1 = %00000110	' Az ADCON1 regiszter 

    ' A timer2 bemenetn az rajel negyede van. (fosc/4)
    ' Ezt osztom elbb 16-al, majd 10-el, s bekapcsolom a Timer2-t: 
    T2CON = %01001110  ' belltjuk 16-ra az elosztt, 10-re msodik osztt, s bekapcsoljuk a TMR2-t.
    ' Van egy PR2 nev regiszter, aminek a tartalmt a proci folyamatosan sszehasonltja a TIMER2 tartalmval
    ' Ha elri, akkor a TIMER2 tartalmt nullzza, s a Timer2 interrupt 
    ' flag bitet, a PIR1.1 -et 1-be rakja.
   
    PR2 = 249           ' 0 to 249 = 250. 250*16*15*1uS=60mS
   
		' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban
  	PERC var Byte
    MP var Byte
    ORA var Byte
    tiktak var Byte 
  	MPBIT var BIT
    
	
			
			' Set TMR0 to interrupt every 16.384 milliMPs
	OPTION_REG = $55    ' Set TMR0 configuration and enable PORTB pullups
	INTCON = $a0 		' Enable TMR0 interrupts
    
nullaz: 
    ORA = 0 
    PERC = 0  
	MP = 0
    tiktak = 0
     
main:
   
    if MPBIT THEN    ' Ha az "eltelt egy msodperc" jelz bit 1, akkor:
        LCDOUT $fe,$80,"Ora: ",DEC2 ORA," Perc: ",dec2 PERC ' LCD trles, es irs az els sorba
        LCDOUT $fe,$C0,"Masodperc: ",DEC2 MP   ' a msodik sorba a msodperceket rjuk ki
        toggle PIROSLED  ' tkapcsoljuk a LED llapott.
        MPBIT = 0        ' s leoltjuk a jelzbitnket
    endif        
   
'Szval ha 4 megs a kvarc, akkor az fosc/4 ugye 1.000.000 Hz. Ezt osztjuk elbb 16-al, majd 10-el.
'Teht 6250 Hz-es jel lpteti a TMR2 szmllt, s 250 lps utn lesz azonos az rtke a PR2-vel.
'Ekkor 1-be ugrik a PIR1.1 nev bit. Ezzel egy jabb 250-es osztst tudtunk csinlni.
'A 6250/250=25 Hz. Szval ez msodpercenknt 25-szr fog megtrtnni. Vagy 40 millisecundumonknt, ahogy tetszik.     
'Szval mg egy 25-s oszts, s meg van az htott 1 msodperces idalapunk. Na teht:
   
    If PIR1.1 = 1 Then        ' Ha a TIMER2 TMR2 elrte a PR2 rtkt, akkor:
      PIR1.1 = 0             ' nullzzuk a PIR1.1 jelzbitet      
      tiktak = tiktak + 1    ' Minden 40mS utn eggyel n    
      If tiktak < 25 Then timerexit 'Ha mg nem rtk el a 25-t, kiugrunk
	
					' 25 x 0.04 = 1, azaz egy msodperc eltelt!
        tiktak = 0  ' kezdjk ellrl a szmolst
        MP = MP + 1 ' s nveljk a msodpercek szmt       
        MPBIT = 1   ' van egy "eltelt egy msodperc" jelz bitnk, azt is bebillentjk
  
	If MP >= 60 Then  ' ha elrte a msodpercek szma a 60-at, akkor
                PERC = PERC + 1  'nveljk eggyel a percek szmt
                MP = 0           'msodperceket pedig nullzzuk
		If PERC >= 60 Then   ' ha elrte a percek szma a 60-at, akkor
                ORA = ORA + 1 ' eggyel lptetjk az ra szmllt
		        PERC = 0      ' a percszmllt meg nulzzuk
                        If ORA >= 24 Then  'Ha az rk szma mr 24 lenne, 
                                ORA = 0    'akkor nullzzuk
                        Endif
                Endif
        Endif
    timerexit: 
    endif
 

    goto main		' Ugras a ciklus elejere, kezdodik minden ujra... 

    END				' Itt a progi vege. 
