'Egy BASIC mintaprogram a PICDEMO panelre.
'Az A0 analog bemenet beolvassa, az eredmeny kiirja az LCD-re, es kivezerlesmerokent mukodteti az L0-7 LED-eket 

' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
' analg portnak hasznlni, mi legyen a mrs referencia feszltsge. 
' Ezeket az ANSELA-B-C-D, az ADCON0 s ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
' Szval, ha azt akarjuk, hogy a PORTA.0-1-3 mint analog,
' a PORTA.2-4-5 mint digitlis port legyen hasznlva, a
' a mrs referencia feszltsge pedig a tpfesz legyen, akkor:

' Akr 14 lb hasznlhat analg bemenetnek, de most csak a porta 0-3 legyen analg, a tbbi digitlis.
   ANSELA = %00001111    ' porta 0-3 analg, a 4-7 digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis
   
	ADCON0 = %00000000	' Az ADC0, ADC ON regiszter 
'Balra igaztva az eredmny, Fosc/4 az A/D rajel, az ADref- a VSS, ADref+ a VCC :
	ADCON1 = %01000000	' Az ADref- a VSS, ADref+ a VCC  

'Kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
   	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	4	' Az els adatvezetk az RD.4
	DEFINE LCD_RSREG 	PORTC ' Az LCD Register Select kivezetse a C portra csatlakozik,
	DEFINE LCD_RSBIT 	0	' mgpedig az RC.0 labra. (Tehat az LCD RS - az RC.0 porton van.)
	DEFINE LCD_EREG 	PORTC ' Az enable vezerl bit is a C porton,
	DEFINE LCD_EBIT 	1	' az RC1 portra van kiosztva. (LCD EN - RC.1 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD
	
	LCDOUT $fe,1	    		' LCD torles, es iras az elso sorba
	LCDOUT "*** Mikroklub***"
	LCDOUT $fe,$C0	    		' LCD torles, es iras a masodik sorba
	LCDOUT "www.mikroklub.hu"
	
	PAUSE 3000			' 3 masodperc szunet. (Egy kis pause...)

	TRISB = %00000000	' A PORTB 0-7 mind kimenet legyen! (Itt vezereljuk majd a LED sort.)
	ADCON1 = 0		' A nullas analog port, A0 lesz beolvasva (Ide van kotve a P1 poti)
	LEDEK var byte		' Helyet foglalunk a valtozoknak a mikrokontroller RAM-jaban
	ANAL0 var byte
	LSZAM var byte
	
main:	ADCIN 0, ANAL0			' Beolvassuk az AN0 bemenetet az ANAL0 valtozoba
	LCDOUT $fe,1," Poti= ",#ANAL0	' LCD torles, es iras az elso sorba

	LSZAM = ANAL0/32	' Egy kis matek, a LED kivezerlesmerohoz. A beolvasott erteket osztjuk 32-vel
	LEDEK = %11111111	' Ez lesz a kiindulo ertek, azaz minden bit 1-es
	LEDEK = LEDEK << LSZAM	' Aztan annyi "nulla" bitet tolunk be, ahanyszor az ANAL0-ban meg volt a 32
	PORTB = LEDEK		' Az eredmnyt a betoltjuk PORTB-be, azaz kiadjuk a 8 LED-re!

	PAUSE 500		' 500 msec, azaz fl masodperc pause
	TOGGLE PORTC.7		' Az RC7 porton vezerelt L9 LED ki/bekapcsolgatsa (Mukodesjelzes)
		
	GOTO main		' Ugras a ciklus elejere, kezdodik minden ujra... 
	END	' Itt a progi vege. Ha tekergetjuk a potit, latjuk az eredmenyt az LCD-n, futnak a LED-ek
